#! /usr/bin/env node

const params = process.argv.slice(4);
const myModule = require(process.argv[2]);

if (!myModule) {
  throw new Error(`No module named ${myModule} found`);
}
if (!myModule[process.argv[3]]) {
  throw new Error(`${process.argv[3]} is not a function exported from ${myModule}`);
}

var EXIT = false;

var callback = function ( err, result ) {
    if( err ) {
        console.log( "ERROR : " + err );
        EXIT = true;
    }    
    else {
        var fs = require('fs');
        fs.writeFile("./RETURN_VAL", result , function(error) {
            if(error) {
                console.log(error);
                EXIT = true;
            }

            console.log("The file was saved!");
       });
    }
    EXIT = true;
}

myModule[process.argv[3]]( params[0], params[1], callback );
(function wait () {
    var handles = process._getActiveRequests();
    console.log( handles );
    console.log( "loop handles (" + handles.size + ") : ");
    handles.forEach(function (handle) {
        console.log( "\t" + handle );
    });

    var requests = process._getActiveRequests();
    console.log( requests );
    console.log( "loop requests (" + requests.size + ")");
    if (!EXIT) setTimeout( wait, 100 );

})();
